\ Copyright (c) 2022 Michael Scholz <mike@fth-devel.net>
\ All rights reserved.
\
\ Redistribution and use in source and binary forms, with or without
\ modification, are permitted provided that the following conditions
\ are met:
\ 1. Redistributions of source code must retain the above copyright
\    notice, this list of conditions and the following disclaimer.
\ 2. Redistributions in binary form must reproduce the above copyright
\    notice, this list of conditions and the following disclaimer in the
\    documentation and/or other materials provided with the distribution.
\
\ THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
\ ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
\ IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
\ ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
\ FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
\ DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
\ OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
\ HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
\ LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
\ OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
\ SUCH DAMAGE.
\
\ @(#)dbm.fs	1.2 12/15/22

\ dbm-keys	( db -- keys )
\ dbm-values	( db -- vals )
\ dbm-search	( db reg -- res )
\
\ dbm-test	( -- )

"dl-load dbm Init_dbm" <'> string-eval 'so-file-error nil fth-catch [if]
	stack-reset
	skip-file
[then]

hide
: dbm-keys-cb { ary -- prc; k v self -- ary }
	2 proc-create ( prc )
	ary ,
  does> { k v self -- ary }
	self @ { ary }
	ary k array-push
;

: dbm-values-cb { ary -- prc; k v self -- ary }
	2 proc-create ( prc )
	ary ,
  does> { k v self -- ary }
	self @ ( ary ) v array-push
;

: dbm-search-cb { ary reg -- prc; k v self -- }
	2 proc-create ( prc )
	ary ,
	reg ,
  does> { k v self -- }
	self @ { ary }
	self cell+ @ { reg }
	reg k re= if
		ary v array-push drop
	then
;
set-current

: dbm-keys { db -- res }
	doc" keys as array
Returns db's keys as array.
See also dbm-values."
	#() { ary }
	db ary dbm-keys-cb dbm-each
	ary
;

: dbm-values { db -- res }
	doc" values as array
Returns db's values as array.
See also dbm-keys."
	#() { ary }
	db ary dbm-values-cb dbm-each
	ary
;

: dbm-search { db reg -- res }
	doc" search for REGexp
Returns an array of all values where keys match REGexp.
See also array-search and hash-search."
	#() { ary }
	db ary reg dbm-search-cb dbm-each
	ary
;
previous

: dbm-test ( -- )
	"test-dbm" { dbf }
	dbf ".db" $+ { db-file }
	dbf dbm{ 0 1 2 3 } { db }
	db dbm-keys . cr
	db dbm-values . cr
	db /0|2/ dbm-search . cr
	db dbm-close
	db-file file-delete
;

\ dbm.fs ends here
